diff -r f6ef988fda71 trytond/model/modelsql.py
--- a/trytond/model/modelsql.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/modelsql.py	Sun Sep 23 17:30:03 2012 +0200
@@ -1051,110 +1042,110 @@
             sub_ids = ids[i:i + cursor.IN_MAX]
             red_sql, red_ids = reduce_ids('id', sub_ids)
             if domain1:
-                cursor.execute('SELECT id FROM "' + self._table + '" '
+                cursor.execute('SELECT id FROM "' + cls._table + '" '
                     'WHERE ' + red_sql + ' ' + domain1,
                     red_ids + domain2)
                 rowcount = cursor.rowcount
                 if rowcount == -1 or rowcount is None:
                     rowcount = len(cursor.fetchall())
                 if not rowcount == len({}.fromkeys(sub_ids)):
-                    self.raise_user_error('access_error', self._description)
+                    cls.raise_user_error('access_error', cls._description)
 
-        self.trigger_delete(ids)
+        cls.trigger_delete(records)
 
         for i in range(0, len(ids), cursor.IN_MAX):
             sub_ids = ids[i:i + cursor.IN_MAX]
+            sub_records = records[i:i + cursor.IN_MAX]
             red_sql, red_ids = reduce_ids('id', sub_ids)
 
-            Transaction().delete_records.setdefault(self._name,
+            Transaction().delete_records.setdefault(cls.__name__,
                     set()).update(sub_ids)
 
-            for model, field_name in foreign_keys_toupdate:
-                if not hasattr(model, 'search') \
-                        or not hasattr(model, 'write'):
+            for Model, field_name in foreign_keys_toupdate:
+                if (not hasattr(Model, 'search')
+                        or not hasattr(Model, 'write')):
                     continue
                 red_sql2, red_ids2 = reduce_ids('"' + field_name + '"',
                     sub_ids)
-                cursor.execute('SELECT id FROM "' + model._table + '" '
+                cursor.execute('SELECT id FROM "' + Model._table + '" '
                     'WHERE ' + red_sql2, red_ids2)
-                model_ids = [x[0] for x in cursor.fetchall()]
-                if model_ids:
-                    model.write(model_ids, {
-                        field_name: False,
-                        })
+                models = Model.browse([x[0] for x in cursor.fetchall()])
+                if models:
+                    Model.write(models, {
+                            field_name: False,
+                            })
 
-            for model, field_name in foreign_keys_todelete:
-                if not hasattr(model, 'search') \
-                        or not hasattr(model, 'delete'):
+            for Model, field_name in foreign_keys_todelete:
+                if (not hasattr(Model, 'search')
+                        or not hasattr(Model, 'delete')):
                     continue
                 red_sql2, red_ids2 = reduce_ids('"' + field_name + '"',
                     sub_ids)
-                cursor.execute('SELECT id FROM "' + model._table + '" '
+                cursor.execute('SELECT id FROM "' + Model._table + '" '
                     'WHERE ' + red_sql2, red_ids2)
-                model_ids = [x[0] for x in cursor.fetchall()]
-                if model_ids:
-                    model.delete(model_ids)
+                models = Model.browse([x[0] for x in cursor.fetchall()])
+                if models:
+                    Model.delete(models)
 
-            for model, field_name in foreign_keys_tocheck:
+            for Model, field_name in foreign_keys_tocheck:
                 with Transaction().set_user(0):
-                    if model.search([
-                        (field_name, 'in', sub_ids),
-                        ], order=[]):
+                    if Model.search([
+                                (field_name, 'in', sub_ids),
+                                ], order=[]):
                         error_args = []
-                        error_args.append(self._get_error_args('id')[1])
+                        error_args.append(cls._get_error_args('id')[1])
                         error_args.extend(list(
-                            model._get_error_args(field_name)))
-                        self.raise_user_error('foreign_model_exist',
-                                error_args=tuple(error_args))
+                                Model._get_error_args(field_name)))
+                        cls.raise_user_error('foreign_model_exist',
+                            error_args=tuple(error_args))
 
-            super(ModelSQL, self).delete(sub_ids)
+            super(ModelSQL, cls).delete(sub_records)
 
             try:
-                cursor.execute('DELETE FROM "' + self._table + '" '
+                cursor.execute('DELETE FROM "' + cls._table + '" '
                     'WHERE ' + red_sql, red_ids)
             except DatabaseIntegrityError, exception:
                 with Transaction().new_cursor():
-                    for name, _, error in self._sql_constraints:
+                    for name, _, error in cls._sql_constraints:
                         if name in exception[0]:
-                            self.raise_user_error(error)
-                    for name, error in self._sql_error_messages:
+                            cls.raise_user_error(error)
+                    for name, error in cls._sql_error_messages:
                         if name in exception[0]:
-                            self.raise_user_error(error)
+                            cls.raise_user_error(error)
                 raise
 
-        if self._history:
+        if cls._history:
             for obj_id in ids:
-                cursor.execute('INSERT INTO "' + self._table + '__history" ' \
+                cursor.execute('INSERT INTO "' + cls._table + '__history" ' \
                         '(id, write_uid, write_date) VALUES (%s, %s, %s)',
                         (obj_id, Transaction().user, datetime.datetime.now()))
 
         for k in tree_ids.keys():
-            field = self._columns[k]
+            field = cls._fields[k]
             if len(tree_ids[k]) == 1:
-                self._update_tree(tree_ids[k][0], k, field.left, field.right)
+                cls._update_tree(tree_ids[k][0], k, field.left, field.right)
             else:
                 with Transaction().set_user(0):
-                    self._rebuild_tree(k, False, 0)
+                    cls._rebuild_tree(k, False, 0)
 
-        return True
-
-    def search(self, domain, offset=0, limit=None, order=None, count=False,
+    @classmethod
+    def search(cls, domain, offset=0, limit=None, order=None, count=False,
             query_string=False):
         pool = Pool()
-        rule_obj = pool.get('ir.rule')
+        Rule = pool.get('ir.rule')
         cursor = Transaction().cursor
 
         # Get domain clauses
-        qu1, qu2, tables, tables_args = self.search_domain(domain)
+        qu1, qu2, tables, tables_args = cls.search_domain(domain)
 
         # Get order by
         order_by = []
         if order is None or order is False:
-            order = self._order
+            order = cls._order
         for field, otype in order:
             if otype.upper() not in ('DESC', 'ASC'):
                 raise Exception('Error', 'Wrong order type (%s)!' % otype)
-            order_by2, tables2, tables2_args = self._order_calc(field, otype)
+            order_by2, tables2, tables2_args = cls._order_calc(field, otype)
             order_by += order_by2
             for table in tables2:
                 if table not in tables:
@@ -1170,7 +1161,7 @@
             raise Exception('Error', 'Wrong offset type (%s)!' % type(offset))
 
         # construct a clause for the rules :
-        domain1, domain2 = rule_obj.domain_get(self._name, mode='read')
+        domain1, domain2 = Rule.domain_get(cls.__name__, mode='read')
         if domain1:
             if qu1:
                 qu1 += ' AND ' + domain1
@@ -1180,29 +1171,29 @@
 
         if count:
             cursor.execute(cursor.limit_clause(
-                'SELECT COUNT("%s".id) FROM ' % self._table +
+                'SELECT COUNT("%s".id) FROM ' % cls._table +
                     ' '.join(tables) + (qu1 and ' WHERE ' + qu1 or ''),
                     limit, offset), tables_args + qu2)
             res = cursor.fetchall()
             return res[0][0]
         # execute the "main" query to fetch the ids we were searching for
-        select_fields = ['"' + self._table + '".id AS id']
-        if self._history and Transaction().context.get('_datetime') \
+        select_fields = ['"' + cls._table + '".id AS id']
+        if cls._history and Transaction().context.get('_datetime') \
                 and not query_string:
-            select_fields += ['COALESCE("' + self._table + '".write_date, "'
-                + self._table + '".create_date) AS _datetime']
+            select_fields += ['COALESCE("' + cls._table + '".write_date, "'
+                + cls._table + '".create_date) AS _datetime']
         if not query_string:
             select_fields += [
-                '"' + self._table + '"."' + name + '" AS "' + name + '"'
-                for name, field in self._columns.iteritems()
+                '"' + cls._table + '"."' + name + '" AS "' + name + '"'
+                for name, field in cls._fields.iteritems()
                 if not hasattr(field, 'get')
                 and name != 'id'
                 and not getattr(field, 'translate', False)
                 and field.loading == 'eager']
-            if not self.table_query():
+            if not cls.table_query():
                 select_fields += ['CAST(EXTRACT(EPOCH FROM '
-                        '(COALESCE("' + self._table + '".write_date, '
-                        '"' + self._table + '".create_date))) AS VARCHAR'
+                        '(COALESCE("' + cls._table + '".write_date, '
+                        '"' + cls._table + '".create_date))) AS VARCHAR'
                         ') AS _timestamp']
         query_str = cursor.limit_clause(
                 'SELECT ' + ','.join(select_fields) + ' FROM ' + \
@@ -1212,13 +1203,13 @@
             return (query_str, tables_args + qu2)
         cursor.execute(query_str, tables_args + qu2)
 
-        datas = cursor.dictfetchmany(cursor.IN_MAX)
+        rows = cursor.dictfetchmany(cursor.IN_MAX)
         cache = cursor.get_cache()
-        cache.setdefault(self._name, LRUDict(RECORD_CACHE_SIZE))
-        delete_records = Transaction().delete_records.setdefault(self._name,
+        cache.setdefault(cls.__name__, LRUDict(RECORD_CACHE_SIZE))
+        delete_records = Transaction().delete_records.setdefault(cls.__name__,
                 set())
         keys = None
-        for data in islice(datas, 0, cache.size_limit):
+        for data in islice(rows, 0, cache.size_limit):
             if data['id'] in delete_records:
                 continue
             if not keys:
@@ -1227,17 +1218,17 @@
                     if k in ('_timestamp', '_datetime'):
                         keys.remove(k)
                         continue
-                    field = self._columns[k]
+                    field = cls._fields[k]
                     if field._type not in ('many2one',):
                         keys.remove(k)
                         continue
             for k in keys:
                 del data[k]
-            cache[self._name].setdefault(data['id'], {}).update(data)
+            cache[cls.__name__].setdefault(data['id'], {}).update(data)
 
-        if len(datas) >= cursor.IN_MAX:
+        if len(rows) >= cursor.IN_MAX:
             select_fields2 = [select_fields[0]]
-            if (self._history
+            if (cls._history
                     and Transaction().context.get('_datetime')
                     and not query_string):
                 select_fields2 += [select_fields[1]]
@@ -1247,14 +1238,14 @@
                         'SELECT ' + ','.join(select_fields2) + ' FROM ' + \
                         ' '.join(tables) + (qu1 and ' WHERE ' + qu1 or '') + \
                         (order_by and ' ORDER BY ' + order_by or ''),
-                        limit, offset) + ') AS "' + self._table + '"',
+                        limit, offset) + ') AS "' + cls._table + '"',
                     tables_args + qu2)
-            datas = cursor.dictfetchall()
+            rows = cursor.dictfetchall()
 
-        if self._history and Transaction().context.get('_datetime'):
+        if cls._history and Transaction().context.get('_datetime'):
             res = []
             ids_date = {}
-            for data in datas:
+            for data in rows:
                 if data['id'] in ids_date:
                     if data['_datetime'] <= ids_date[data['id']]:
                         continue
@@ -1269,50 +1260,45 @@
                 cursor.execute(('SELECT id, write_date '
                         'FROM "%s__history" WHERE %s'
                         'AND (write_date IS NOT NULL AND create_date IS NULL)'
-                        ) % (self._table, reduced_sql),
+                        ) % (cls._table, reduced_sql),
                     reduced_ids)
                 for deleted_id, delete_date in cursor.fetchall():
                     if ids_date[deleted_id] < delete_date:
                         to_delete.add(deleted_id)
-            return filter(lambda x: x not in to_delete, res)
+            return cls.browse(filter(lambda x: x not in to_delete, res))
 
-        return [x['id'] for x in datas]
+        return cls.browse([x['id'] for x in rows])
 
-    def search_domain(self, domain, active_test=True):
+    @classmethod
+    def search_domain(cls, domain, active_test=True):
         '''
-        Return SQL clause and arguments for the domain
-
-        :param domain: a domain like in search
-        :param active_test: a boolean to add 'active' test
-        :return: a tuple with
-            - a SQL clause string
-            - a list of arguments for the SQL clause
-            - a list of tables used in the SQL clause
-            - a list of arguments for the tables
+        Return SQL clause, tables to use and arguments for the domain
+        Set active_test to add it.
         '''
-        domain = self._search_domain_active(domain, active_test=active_test)
+        domain = cls._search_domain_active(domain, active_test=active_test)
 
         table_query = ''
         tables_args = []
-        if self.table_query():
-            table_query, tables_args = self.table_query()
+        if cls.table_query():
+            table_query, tables_args = cls.table_query()
             table_query = '(' + table_query + ') AS '
 
-        if self._history and Transaction().context.get('_datetime'):
-            table_query = '"' + self._table + '__history" AS '
+        if cls._history and Transaction().context.get('_datetime'):
+            table_query = '"' + cls._table + '__history" AS '
 
-        tables = [table_query + '"' + self._table + '"']
+        tables = [table_query + '"' + cls._table + '"']
 
-        qu1, qu2 = self.__search_domain_oper(domain, tables, tables_args)
-        if self._history and Transaction().context.get('_datetime'):
+        qu1, qu2 = cls.__search_domain_oper(domain, tables, tables_args)
+        if cls._history and Transaction().context.get('_datetime'):
             if qu1:
                 qu1 += ' AND'
-            qu1 += ' (COALESCE("' + self._table + '".write_date, "' + \
-                    self._table + '".create_date) <= %s)'
+            qu1 += ' (COALESCE("' + cls._table + '".write_date, "' + \
+                    cls._table + '".create_date) <= %s)'
             qu2 += [Transaction().context['_datetime']]
         return qu1, qu2, tables, tables_args
 
-    def __search_domain_oper(self, domain, tables, tables_args):
+    @classmethod
+    def __search_domain_oper(cls, domain, tables, tables_args):
         operator = 'AND'
         if len(domain) and isinstance(domain[0], basestring):
             if domain[0] not in ('AND', 'OR'):
@@ -1331,14 +1317,14 @@
             elif isinstance(arg, list):
                 list_args.append(arg)
 
-        qu1, qu2 = self.__search_domain_calc(tuple_args, tables, tables_args)
+        qu1, qu2 = cls.__search_domain_calc(tuple_args, tables, tables_args)
         if len(qu1):
             qu1 = (' ' + operator + ' ').join(qu1)
         else:
             qu1 = ''
 
         for domain2 in list_args:
-            qu1b, qu2b = self.__search_domain_oper(domain2, tables,
+            qu1b, qu2b = cls.__search_domain_oper(domain2, tables,
                     tables_args)
             if not qu1b:
                 qu1b = '%s'
@@ -1352,30 +1338,31 @@
             qu1 = '(' + qu1 + ')'
         return qu1, qu2
 
-    def __search_domain_calc(self, domain, tables, tables_args):
+    @classmethod
+    def __search_domain_calc(cls, domain, tables, tables_args):
         pool = Pool()
         domain = domain[:]
         cursor = Transaction().cursor
 
         def column_get(model, field_name):
-            field = model._columns.get(field_name)
+            field = model._fields.get(field_name)
             if not field:
                 if not field_name in model._inherit_fields:
                     raise Exception('ValidateError', 'Field "%s" doesn\'t ' \
-                            'exist on "%s"' % (field_name, model._name))
+                            'exist on "%s"' % (field_name, model.__name__))
                 parent_model = pool.get(model._inherit_fields[field_name][0])
                 field = column_get(parent_model, field_name)
             return field
 
         def get_model_for_field(model, field):
-            if field in model._columns:
+            if field in model._fields:
                 return model
             else:
                 parent_model = pool.get(model._inherit_fields[field][0])
                 return get_model_for_field(parent_model, field)
 
         def get_inherits_join(model, field):
-            if field in model._columns:
+            if field in model._fields:
                 return []
             itable = pool.get(model._inherit_fields[field][0])
             table_query = ''
@@ -1386,7 +1373,7 @@
             table_join = 'LEFT JOIN ' + table_query + \
                     '"' + itable._table + '" ON ' \
                     '"%s".id = "%s"."%s"' % (itable._table, model._table,
-                            model._inherits[itable._name])
+                            model._inherits[itable.__name__])
             inherits = [(table_join, table_arg)]
             inherits.extend(get_inherits_join(itable, field))
             return inherits
@@ -1399,88 +1386,91 @@
         joins = []
         while i < len(domain):
             fargs = domain[i][0].split('.', 1)
-            if fargs[0] in self._inherit_fields:
-                inherit_joins = get_inherits_join(self, fargs[0])
+            if fargs[0] in cls._inherit_fields:
+                inherit_joins = get_inherits_join(cls, fargs[0])
                 for (table_join, table_arg) in inherit_joins:
                     if table_join not in tables:
                         tables.append(table_join)
                         tables_args.extend(table_arg)
 
-            field = column_get(self, fargs[0])
-            table = get_model_for_field(self, fargs[0])
+            field = column_get(cls, fargs[0])
+            table = get_model_for_field(cls, fargs[0])
             if len(fargs) > 1:
                 if field._type == 'many2one':
-                    target_obj = pool.get(field.model_name)
+                    Target = pool.get(field.model_name)
                     m2o_search = [(fargs[1], domain[i][1], domain[i][2])]
-                    if ('active' in target_obj._columns
-                            or 'active' in target_obj._inherit_fields):
+                    if ('active' in Target._fields
+                            or 'active' in Target._inherit_fields):
                         m2o_search += [('active', 'in', (True, False))]
                     if hasattr(field, 'search'):
                         domain.extend([(fargs[0], 'in',
-                                    target_obj.search(m2o_search, order=[]))])
+                                    map(int, Target.search(m2o_search,
+                                            order=[])))])
                         domain.pop(i)
                     else:
                         domain[i] = (fargs[0], 'inselect',
-                            target_obj.search(m2o_search, order=[],
+                            Target.search(m2o_search, order=[],
                                 query_string=True), table)
                         i += 1
                     continue
                 elif field._type in ('one2one', 'many2many', 'one2many'):
                     if hasattr(field, 'model_name'):
-                        target_obj = pool.get(field.model_name)
+                        Target = pool.get(field.model_name)
                     else:
-                        target_obj = field.get_target()
+                        Target = field.get_target()
                     if hasattr(field, 'relation_name'):
-                        relation_obj = pool.get(field.relation_name)
+                        Relation = pool.get(field.relation_name)
                         origin, target = field.origin, field.target
                     else:
-                        relation_obj = target_obj
+                        Relation = Target
                         origin, target = field.field, 'id'
-                    if origin in relation_obj._columns:
-                        rev_field = relation_obj._columns[origin]
+                    if origin in Relation._fields:
+                        rev_field = Relation._fields[origin]
                     else:
-                        rev_field = relation_obj._inherit_fields[origin][2]
+                        rev_field = Relation._inherit_fields[origin][2]
                     if rev_field._type == 'reference':
                         sql_type = FIELDS[
-                            self.id._type].sql_type(self.id)[0]
+                            cls.id._type].sql_type(cls.id)[0]
                         origin = ('CAST(SPLIT_PART("%s", \',\', 2) AS %s)'
                             % (origin, sql_type))
                     else:
                         origin = '"%s"' % origin
                     if hasattr(field, 'search'):
-                        domain.extend([(fargs[0], 'in', target_obj.search([
-                            (fargs[1], domain[i][1], domain[i][2]),
-                            ], order=[]))])
+                        domain.extend([(fargs[0], 'in',
+                                    map(int, Target.search([
+                                                (fargs[1], domain[i][1],
+                                                    domain[i][2]),
+                                                ], order=[])))])
                         domain.pop(i)
                     else:
-                        query1, query2 = target_obj.search([
+                        query1, query2 = Target.search([
                             (fargs[1], domain[i][1], domain[i][2]),
                             ], order=[], query_string=True)
                         query1 = ('SELECT %s FROM "%s" WHERE "%s" IN (%s)' %
-                                (origin, relation_obj._table, target, query1))
+                                (origin, Relation._table, target, query1))
                         domain[i] = ('id', 'inselect', (query1, query2))
                         i += 1
                     continue
                 else:
                     raise Exception('ValidateError', 'Clause on field "%s" ' \
                             'doesn\'t work on "%s"' %
-                            (domain[i][0], self._name))
+                            (domain[i][0], cls.__name__))
             if hasattr(field, 'search'):
                 clause = domain.pop(i)
                 domain.extend(field.search(table, clause[0], clause))
             elif field._type == 'one2many':
-                field_obj = pool.get(field.model_name)
+                Field = pool.get(field.model_name)
                 table_query = ''
                 table_args = []
-                if field_obj.table_query():
-                    table_query, table_args = field_obj.table_query()
+                if Field.table_query():
+                    table_query, table_args = Field.table_query()
                     table_query = '(' + table_query + ') AS '
-                if field.field in field_obj._columns:
-                    rev_field = field_obj._columns[field.field]
+                if field.field in Field._fields:
+                    rev_field = Field._fields[field.field]
                 else:
-                    rev_field = field_obj._inherit_fields[field.field][2]
+                    rev_field = Field._inherit_fields[field.field][2]
                 if rev_field._type == 'reference':
-                    sql_type = FIELDS[self.id._type].sql_type(self.id)[0]
+                    sql_type = FIELDS[cls.id._type].sql_type(cls.id)[0]
                     select = ('CAST(SPLIT_PART("%s", \',\', 2) AS %s)'
                         % (field.field, sql_type))
                 else:
@@ -1489,7 +1479,7 @@
                 if isinstance(domain[i][2], bool) or domain[i][2] is None:
                     query1 = 'SELECT ' + select + ' ' \
                             'FROM ' + table_query + \
-                                '"' + field_obj._table + '" ' \
+                                '"' + Field._table + '" ' \
                             'WHERE "' + field.field + '" IS NOT NULL'
                     query2 = table_args
                     clause = 'inselect'
@@ -1501,12 +1491,12 @@
                         target_field = 'rec_name'
                     else:
                         target_field = 'id'
-                    query1, query2 = field_obj.search([
+                    query1, query2 = Field.search([
                             (target_field, domain[i][1], domain[i][2]),
                             ], order=[], query_string=True)
                     query1 = ('SELECT ' + select + ' '
                         'FROM ' + table_query +
-                            '"' + field_obj._table + '" '
+                            '"' + Field._table + '" '
                         'WHERE id IN (' + query1 + ')')
                     query2 = table_args + query2
                     domain[i] = ('id', 'inselect', (query1, query2))
@@ -1514,14 +1504,14 @@
             elif field._type in ('many2many', 'one2one'):
                 # XXX must find a solution for long id list
                 if hasattr(field, 'model_name'):
-                    target_obj = pool.get(field.model_name)
+                    Target = pool.get(field.model_name)
                 else:
-                    target_obj = field.get_target()
+                    Target = field.get_target()
                 if domain[i][1] in ('child_of', 'not child_of'):
                     if isinstance(domain[i][2], basestring):
-                        ids2 = [x[0] for x in target_obj.search([
-                            ('rec_name', 'ilike', domain[i][2]),
-                            ], order=[])]
+                        ids2 = map(int, Target.search([
+                                    ('rec_name', 'ilike', domain[i][2]),
+                                    ], order=[]))
                     elif isinstance(domain[i][2], (int, long)):
                         ids2 = [domain[i][2]]
                     else:
@@ -1530,25 +1520,25 @@
                     def _rec_get(ids, table, parent):
                         if not ids:
                             return []
-                        ids2 = table.search([
-                            (parent, 'in', ids),
-                            (parent, '!=', False),
-                            ], order=[])
+                        ids2 = map(int, table.search([
+                                    (parent, 'in', ids),
+                                    (parent, '!=', None),
+                                    ], order=[]))
                         return ids + _rec_get(ids2, table, parent)
 
-                    if target_obj._name != table._name:
+                    if Target.__name__ != table.__name__:
                         if len(domain[i]) != 4:
                             raise Exception('Error', 'Programming error: '
                                 'child_of on field "%s" is not allowed!'
                                 % domain[i][0])
-                        ids2 = target_obj.search([
-                            (domain[i][3], 'child_of', ids2),
-                            ], order=[])
-                        relation_obj = pool.get(field.relation_name)
+                        ids2 = map(int, Target.search([
+                                    (domain[i][3], 'child_of', ids2),
+                                    ], order=[]))
+                        Relation = pool.get(field.relation_name)
                         red_sql, red_ids = reduce_ids('"' + field.target + '"',
                                 ids2)
                         query1 = 'SELECT "' + field.origin + '" ' \
-                                'FROM "' + relation_obj._table + '" ' \
+                                'FROM "' + Relation._table + '" ' \
                                 'WHERE ' + red_sql + ' ' \
                                     'AND "' + field.origin + '" IS NOT NULL'
                         query2 = red_ids
@@ -1564,19 +1554,19 @@
                             domain[i] = ('id', 'not in', ids2 + _rec_get(ids2,
                                 table, domain[i][0]))
                 else:
-                    relation_obj = pool.get(field.relation_name)
+                    Relation = pool.get(field.relation_name)
                     table_query = ''
                     table_args = []
-                    if relation_obj.table_query():
-                        table_query, table_args = relation_obj.table_query()
+                    if Relation.table_query():
+                        table_query, table_args = Relation.table_query()
                         table_query = '(' + table_query + ') AS '
-                    if field.origin in relation_obj._columns:
-                        origin_field = relation_obj._columns[field.origin]
+                    if field.origin in Relation._fields:
+                        origin_field = Relation._fields[field.origin]
                     else:
                         origin_field = \
-                            relation_obj._inherit_fields[field.origin][2]
+                            Relation._inherit_fields[field.origin][2]
                     if origin_field._type == 'reference':
-                        sql_type = FIELDS[self.id._type].sql_type(self.id)[0]
+                        sql_type = FIELDS[cls.id._type].sql_type(cls.id)[0]
                         select = ('CAST(SPLIT_PART("%s", \',\', 2) AS %s)'
                             % (field.origin, sql_type))
                     else:
@@ -1584,7 +1574,7 @@
                     if isinstance(domain[i][2], bool) or domain[i][2] is None:
                         query1 = 'SELECT ' + select + ' ' \
                                 'FROM ' + table_query + ' '\
-                                    '"' + relation_obj._table + '" ' \
+                                    '"' + Relation._table + '" ' \
                                 'WHERE "' + field.origin + '" IS NOT NULL'
                         query2 = table_args
                         clause = 'inselect'
